Index: main/manager.c
===================================================================
--- main/manager.c	(revision 148468)
+++ main/manager.c	(working copy)
@@ -125,7 +125,11 @@
 static int manager_enabled = 0;
 static int webmanager_enabled = 0;
 
+#define DEFAULT_REALM		"asterisk"
+static char global_realm[MAXHOSTNAMELEN];	/*!< Default realm */
+
 static int block_sockets;
+#define MAX_SESSIONS		256		/*!< Maximum active sessions */
 static int num_sessions;
 
 static int manager_debug;	/*!< enable some debugging code in the manager */
@@ -137,7 +141,8 @@
  * AMI session have managerid == 0; the entry is created upon a connect,
  * and destroyed with the socket.
  * HTTP sessions have managerid != 0, the value is used as a search key
- * to lookup sessions (using the mansession_id cookie).
+ * to lookup sessions (using the mansession_id cookie, or nonce key from
+ * Digest Authentication http header).
  */
 #define MAX_BLACKLIST_CMD_LEN 2
 static struct {
@@ -149,7 +154,6 @@
 
 struct mansession {
 	pthread_t ms_t;		/*!< Execution thread, basically useless */
-	ast_mutex_t __lock;	/*!< Thread lock -- don't use in action callbacks, it's already taken care of  */
 				/* XXX need to document which fields it is protecting */
 	struct sockaddr_in sin;	/*!< address we are connecting from */
 	FILE *f;		/*!< fdopen() on the underlying fd */
@@ -172,14 +176,18 @@
 	struct eventqent *last_ev;	/*!< last event processed. */
 	int writetimeout;	/*!< Timeout for ast_carefulwrite() */
 	int pending_event;         /*!< Pending events indicator in case when waiting_thread is NULL */
+	time_t noncetime;	/*!< Timer for nonce value expiration */
+	unsigned long oldnonce;	/*!< Stale nonce value */
+	unsigned long nc;	/*!< incremental  nonce counter */
 	AST_LIST_HEAD_NOLOCK(mansession_datastores, ast_datastore) datastores; /*!< Data stores on the session */
 	AST_LIST_ENTRY(mansession) list;
 };
 
 #define NEW_EVENT(m)	(AST_LIST_NEXT(m->last_ev, eq_next))
 
-static AST_LIST_HEAD_STATIC(sessions, mansession);
+static struct ao2_container *sessions;
 
+
 /*! \brief user descriptor, as read from the config file.
  *
  * \note It is still missing some fields -- e.g. we can have multiple permit and deny
@@ -193,8 +201,9 @@
 	int readperm;			/*! Authorization for reading */
 	int writeperm;			/*! Authorization for writing */
 	int writetimeout;		/*! Per user Timeout for ast_carefulwrite() */
-	int displayconnects;	/*!< XXX unused */
-	int keep;	/*!< mark entries created on a reload */
+	int displayconnects;		/*!< XXX unused */
+	int keep;			/*!< mark entries created on a reload */
+	char *a1_hash;			/*!< precalculated A1 for Digest auth */
 	AST_RWLIST_ENTRY(ast_manager_user) list;
 };
 
@@ -291,8 +300,9 @@
 	/* the list is never empty now, but may become so when
 	 * we optimize it in the future, so be prepared.
 	 */
-	if (ret)
+	if (ret) {
 		ast_atomic_fetchadd_int(&ret->usecount, 1);
+	}
 	AST_LIST_UNLOCK(&all_events);
 	return ret;
 }
@@ -353,8 +363,9 @@
 		}
 	}
 
-	if ((*res)->used == 0)	/* replace empty string with something sensible */
+	if ((*res)->used == 0) { /* replace empty string with something sensible */
 		ast_str_append(res, 0, "<none>");
+	}
 
 	return (*res)->str;
 }
@@ -370,12 +381,14 @@
 
 	do {
 		if ((next = strchr(val, delim))) {
-			if (!strncmp(val, smallstr, (next - val)))
+			if (!strncmp(val, smallstr, (next - val))) {
 				return 1;
-			else
+			} else {
 				continue;
-		} else
+			}
+		} else {
 			return !strcmp(smallstr, val);
+		}
 	} while (*(val = (next + 1)));
 
 	return 0;
@@ -385,12 +398,14 @@
 {
 	int x = 0, ret = 0;
 
-	if (!instr)
+	if (!instr) {
 		return 0;
+	}
 
 	for (x = 0; x < ARRAY_LEN(perms); x++) {
-		if (ast_instring(instr, perms[x].label, ','))
+		if (ast_instring(instr, perms[x].label, ',')) {
 			ret |= perms[x].num;
+		}
 	}
 
 	return ret;
@@ -404,36 +419,112 @@
 {
 	const char *p;
 
-	if (ast_strlen_zero(string))
+	if (ast_strlen_zero(string)) {
 		return -1;
+	}
 
-	for (p = string; *p; p++)
-		if (*p < '0' || *p > '9')
+	for (p = string; *p; p++) {
+		if (*p < '0' || *p > '9') {
 			break;
-	if (!p)	/* all digits */
+		}
+	}
+	if (!p)	{ /* all digits */
 		return atoi(string);
-	if (ast_false(string))
+	}
+	if (ast_false(string)) {
 		return 0;
+	}
 	if (ast_true(string)) {	/* all permissions */
 		int x, ret = 0;
-		for (x = 0; x < ARRAY_LEN(perms); x++)
+		for (x = 0; x < ARRAY_LEN(perms); x++) {
 			ret |= perms[x].num;
+		}
 		return ret;
 	}
 	return get_perm(string);
 }
 
+/*
+ * Decrement the usecount for the event; if it goes to zero,
+ * (why check for e->next ?) wakeup the
+ * main thread, which is in charge of freeing the record.
+ * Returns the next record.
+ */
+static struct eventqent *unref_event(struct eventqent *e)
+{
+	ast_atomic_fetchadd_int(&e->usecount, -1);
+	return AST_LIST_NEXT(e, eq_next);
+}
+
+static void ref_event(struct eventqent *e)
+{
+	ast_atomic_fetchadd_int(&e->usecount, 1);
+}
+
+/*! \brief Unreference manager session object.
+     If no more references, then go ahead and delete it */
+static struct mansession *unref_mansession(struct mansession *s)
+{
+	int refcount = ao2_ref(s, -1);
+        if (manager_debug) {
+		ast_log(LOG_DEBUG, "Mansession: %p refcount now %d\n", s, refcount - 1);
+	}
+	return s;
+}
+
+static void session_destructor(void *obj)
+{
+	struct mansession *s = obj;
+	struct eventqent *eqe = s->last_ev;
+
+	if (s->f != NULL) {
+		fclose(s->f);
+	}
+	unref_event(eqe);
+}
+
+/*! \brief Allocate manager session structure and add it to the list of sessions */
+static struct mansession *build_mansession(struct sockaddr_in sin)
+{
+	struct mansession *newsession;
+
+	if (!(newsession = ao2_alloc(sizeof(*newsession), session_destructor))) {
+		return NULL;
+	}
+	memset(newsession, 0, sizeof(*newsession));
+	newsession->fd = -1;
+	newsession->waiting_thread = AST_PTHREADT_NULL;
+	newsession->writetimeout = 100;
+	newsession->send_events = -1;
+	newsession->sin = sin;
+	ast_atomic_fetchadd_int(&num_sessions, 1);
+
+	ao2_link(sessions, newsession);
+
+	return unref_mansession(newsession);
+}
+
+static int mansession_cmp_fn(void *obj, void *arg, int flags)
+{
+	struct mansession *s = obj;
+	char *str = arg;
+	return !strcasecmp(s->username, str) ? CMP_MATCH : 0;
+}
+
+static void session_destroy(struct mansession *s)
+{
+	ao2_unlink(sessions, s);
+	ast_atomic_fetchadd_int(&num_sessions, -1);
+}
+
+
 static int check_manager_session_inuse(const char *name)
 {
-	struct mansession *session = NULL;
+	struct mansession *session = ao2_find(sessions, (char*) name, OBJ_POINTER);
 
-	AST_LIST_LOCK(&sessions);
-	AST_LIST_TRAVERSE(&sessions, session, list) {
-		if (!strcasecmp(session->username, name)) 
-			break;
+	if (session) {
+		unref_mansession(session);
 	}
-	AST_LIST_UNLOCK(&sessions);
-
 	return session ? 1 : 0;
 }
 
@@ -447,8 +538,9 @@
 	struct ast_manager_user *user = NULL;
 
 	AST_RWLIST_TRAVERSE(&users, user, list)
-		if (!strcasecmp(user->username, name))
+		if (!strcasecmp(user->username, name)) {
 			break;
+		}
 	return user;
 }
 
@@ -462,8 +554,9 @@
 	int ret = 0;
 
 	AST_RWLIST_RDLOCK(&users);
-	if ((user = get_manager_by_name_locked (s->username)))
+	if ((user = get_manager_by_name_locked (s->username))) {
 		ret = user->displayconnects;
+	}
 	AST_RWLIST_UNLOCK(&users);
 	
 	return ret;
@@ -496,8 +589,9 @@
 		return ret;
 	}
 	authority = ast_str_alloca(80);
-	if (a->argc != 4)
+	if (a->argc != 4) {
 		return CLI_SHOWUSAGE;
+	}
 
 	AST_RWLIST_RDLOCK(&actions);
 	AST_RWLIST_TRAVERSE(&actions, cur, list) {
@@ -525,15 +619,17 @@
 	case CLI_GENERATE:
 		return NULL;	
 	}
-	if (a->argc == 3)
+	
+	if (a->argc == 3) {
 		ast_cli(a->fd, "manager debug is %s\n", manager_debug? "on" : "off");
-	else if (a->argc == 4) {
-		if (!strcasecmp(a->argv[3], "on"))
+	} else if (a->argc == 4) {
+		if (!strcasecmp(a->argv[3], "on")) {
 			manager_debug = 1;
-		else if (!strcasecmp(a->argv[3], "off"))
+		} else if (!strcasecmp(a->argv[3], "off")) {
 			manager_debug = 0;
-		else
+		} else {
 			return CLI_SHOWUSAGE;
+		}
 	}
 	return CLI_SUCCESS;
 }
@@ -556,8 +652,9 @@
 	case CLI_GENERATE:
 		l = strlen(a->word);
 		which = 0;
-		if (a->pos != 3)
+		if (a->pos != 3) {
 			return NULL;
+		}
 		AST_RWLIST_RDLOCK(&users);
 		AST_RWLIST_TRAVERSE(&users, user, list) {
 			if ( !strncasecmp(a->word, user->username, l) && ++which > a->n ) {
@@ -569,8 +666,9 @@
 		return ret;
 	}
 
-	if (a->argc != 4)
+	if (a->argc != 4) {
 		return CLI_SHOWUSAGE;
+	}
 
 	AST_RWLIST_RDLOCK(&users);
 
@@ -616,8 +714,9 @@
 	case CLI_GENERATE:
 		return NULL;
 	}
-	if (a->argc != 3)
+	if (a->argc != 3) {
 		return CLI_SHOWUSAGE;
+	}
 
 	AST_RWLIST_RDLOCK(&users);
 
@@ -637,9 +736,8 @@
 
 	AST_RWLIST_UNLOCK(&users);
 
-	ast_cli(a->fd, "-------------------\n");
-	ast_cli(a->fd, "%d manager users configured.\n", count_amu);
-
+	ast_cli(a->fd,"-------------------\n"
+		      "%d manager users configured.\n", count_amu);
 	return CLI_SUCCESS;
 }
 
@@ -680,6 +778,8 @@
 #define HSMCONN_FORMAT1 "  %-15.15s  %-15.15s  %-10.10s  %-10.10s  %-8.8s  %-8.8s  %-5.5s  %-5.5s\n"
 #define HSMCONN_FORMAT2 "  %-15.15s  %-15.15s  %-10d  %-10d  %-8d  %-8d  %-5.5d  %-5.5d\n"
 	int count = 0;
+	struct ao2_iterator i;
+	
 	switch (cmd) {
 	case CLI_INIT:
 		e->command = "manager show connected";
@@ -694,12 +794,14 @@
 
 	ast_cli(a->fd, HSMCONN_FORMAT1, "Username", "IP Address", "Start", "Elapsed", "FileDes", "HttpCnt", "Read", "Write");
 
-	AST_LIST_LOCK(&sessions);
-	AST_LIST_TRAVERSE(&sessions, s, list) {
+	i = ao2_iterator_init(sessions, 0);
+	while ((s = ao2_iterator_next(&i))) {
+		ao2_lock(s);
 		ast_cli(a->fd, HSMCONN_FORMAT2, s->username, ast_inet_ntoa(s->sin.sin_addr), (int)(s->sessionstart), (int)(now - s->sessionstart), s->fd, s->inuse, s->readperm, s->writeperm);
 		count++;
+		ao2_unlock(s);
+		unref_mansession(s);
 	}
-	AST_LIST_UNLOCK(&sessions);
 
 	ast_cli(a->fd, "%d users connected.\n", count);
 
@@ -746,8 +848,9 @@
 	case CLI_GENERATE:
 		return NULL;
 	}
-	if (a->argc > 2)
+	if (a->argc > 2) {
 		return CLI_SHOWUSAGE;
+	}
 	reload_manager();
 	return CLI_SUCCESS;
 }
@@ -765,53 +868,6 @@
 };
 
 /*
- * Decrement the usecount for the event; if it goes to zero,
- * (why check for e->next ?) wakeup the
- * main thread, which is in charge of freeing the record.
- * Returns the next record.
- */
-static struct eventqent *unref_event(struct eventqent *e)
-{
-	ast_atomic_fetchadd_int(&e->usecount, -1);
-	return AST_LIST_NEXT(e, eq_next);
-}
-
-static void ref_event(struct eventqent *e)
-{
-	ast_atomic_fetchadd_int(&e->usecount, 1);
-}
-
-/*
- * destroy a session, leaving the usecount
- */
-static void free_session(struct mansession *s)
-{
-	struct eventqent *eqe = s->last_ev;
-	struct ast_datastore *datastore;
-
-	/* Get rid of each of the data stores on the session */
-	while ((datastore = AST_LIST_REMOVE_HEAD(&s->datastores, entry))) {
-		/* Free the data store */
-		ast_datastore_free(datastore);
-	}
-
-	if (s->f != NULL)
-		fclose(s->f);
-	ast_mutex_destroy(&s->__lock);
-	ast_free(s);
-	unref_event(eqe);
-}
-
-static void destroy_session(struct mansession *s)
-{
-	AST_LIST_LOCK(&sessions);
-	AST_LIST_REMOVE(&sessions, s, list);
-	ast_atomic_fetchadd_int(&num_sessions, -1);
-	free_session(s);
-	AST_LIST_UNLOCK(&sessions);
-}
-
-/*
  * Generic function to return either the first or the last matching header
  * from a list of variables, possibly skipping empty strings.
  * At the moment there is only one use of this function in this file,
@@ -867,20 +923,24 @@
 	for (x = 0; x < m->hdrcount; x++) {
 		char *parse, *var, *val;
 
-		if (strncasecmp("Variable: ", m->headers[x], varlen))
+		if (strncasecmp("Variable: ", m->headers[x], varlen)) {
 			continue;
+		}
 		parse = ast_strdupa(m->headers[x] + varlen);
 
 		AST_STANDARD_APP_ARGS(args, parse);
-		if (!args.argc)
+		if (!args.argc) {
 			continue;
+		}
 		for (y = 0; y < args.argc; y++) {
-			if (!args.vars[y])
+			if (!args.vars[y]) {
 				continue;
+			}
 			var = val = ast_strdupa(args.vars[y]);
 			strsep(&val, "=");
-			if (!val || ast_strlen_zero(var))
+			if (!val || ast_strlen_zero(var)) {
 				continue;
+			}
 			cur = ast_variable_new(var, val, "");
 			cur->next = head;
 			head = cur;
@@ -905,18 +965,21 @@
 		int elapsed;
 		struct pollfd fd;
 		n = fwrite(src, 1, len, s->f);	/* try to write the string, non blocking */
-		if (n == len /* ok */ || n < 0 /* error */)
+		if (n == len /* ok */ || n < 0 /* error */) {
 			break;
+		}
 		len -= n;	/* skip already written data */
 		src += n;
 		fd.fd = s->fd;
 		fd.events = POLLOUT;
 		n = -1;		/* error marker */
 		elapsed = ast_tvdiff_ms(ast_tvnow(), start);
-		if (elapsed > s->writetimeout)
+		if (elapsed > s->writetimeout) {
 			break;
-		if (poll(&fd, 1, s->writetimeout - elapsed) < 1)
+		}
+		if (poll(&fd, 1, s->writetimeout - elapsed) < 1) {
 			break;
+		}
 	}
 	fflush(s->f);
 	return n < 0 ? -1 : 0;
@@ -941,17 +1004,19 @@
 	va_list ap;
 	struct ast_str *buf;
 
-	if (!(buf = ast_str_thread_get(&astman_append_buf, ASTMAN_APPEND_BUF_INITSIZE)))
+	if (!(buf = ast_str_thread_get(&astman_append_buf, ASTMAN_APPEND_BUF_INITSIZE))) {
 		return;
+	}
 
 	va_start(ap, fmt);
 	ast_str_set_va(&buf, 0, fmt, ap);
 	va_end(ap);
 
-	if (s->f != NULL)
+	if (s->f != NULL) {
 		send_string(s, buf->str);
-	else
+	} else {
 		ast_verbose("fd == -1 in astman_append, should not happen\n");
+	}
 }
 
 /*! \note NOTE: XXX this comment is unclear and possibly wrong.
@@ -976,16 +1041,19 @@
 	const char *id = astman_get_header(m, "ActionID");
 
 	astman_append(s, "Response: %s\r\n", resp);
-	if (!ast_strlen_zero(id))
+	if (!ast_strlen_zero(id)) {
 		astman_append(s, "ActionID: %s\r\n", id);
-	if (listflag)
+	}
+	if (listflag) {
 		astman_append(s, "Eventlist: %s\r\n", listflag);	/* Start, complete, cancelled */
-	if (msg == MSG_MOREDATA)
+	}
+	if (msg == MSG_MOREDATA) {
 		return;
-	else if (msg)
+	} else if (msg) {
 		astman_append(s, "Message: %s\r\n\r\n", msg);
-	else
+	} else {
 		astman_append(s, "\r\n");
+	}
 }
 
 void astman_send_response(struct mansession *s, const struct message *m, char *resp, char *msg)
@@ -1022,10 +1090,11 @@
 {
 	int maskint = strings_to_mask(eventmask);
 
-	ast_mutex_lock(&s->__lock);
-	if (maskint >= 0)
+	ao2_lock(s);
+	if (maskint >= 0) {
 		s->send_events = maskint;
-	ast_mutex_unlock(&s->__lock);
+	}
+	ao2_unlock(s);
 
 	return maskint;
 }
@@ -1044,8 +1113,9 @@
 	int error = -1;
 	struct ast_manager_user *user = NULL;
 
-	if (ast_strlen_zero(username))	/* missing username */
+	if (ast_strlen_zero(username)) {	/* missing username */
 		return -1;
+	}
 
 	/* locate user in locked state */
 	AST_RWLIST_WRLOCK(&users);
@@ -1069,14 +1139,16 @@
 			MD5Final(digest, &md5);
 			for (x = 0; x < 16; x++)
 				len += sprintf(md5key + len, "%2.2x", digest[x]);
-			if (!strcmp(md5key, key))
+			if (!strcmp(md5key, key)) {
 				error = 0;
+			}
 		} else {
 			ast_debug(1, "MD5 authentication is not possible.  challenge: '%s'\n", 
 				S_OR(s->challenge, ""));
 		}
-	} else if (password && user->secret && !strcmp(password, user->secret))
+	} else if (password && user->secret && !strcmp(password, user->secret)) {
 		error = 0;
+	}
 
 	if (error) {
 		ast_log(LOG_NOTICE, "%s failed to authenticate as '%s'\n", ast_inet_ntoa(s->sin.sin_addr), username);
@@ -1143,13 +1215,15 @@
 		if (ast_strlen_zero(category) || (!ast_strlen_zero(category) && !strcmp(category, cur_category))) {
 			lineno = 0;
 			astman_append(s, "Category-%06d: %s\r\n", catcount, cur_category);
-			for (v = ast_variable_browse(cfg, cur_category); v; v = v->next)
+			for (v = ast_variable_browse(cfg, cur_category); v; v = v->next) {
 				astman_append(s, "Line-%06d-%06d: %s=%s\r\n", catcount, lineno++, v->name, v->value);
+			}
 			catcount++;
 		}
 	}
-	if (!ast_strlen_zero(category) && catcount == 0) /* TODO: actually, a config with no categories doesn't even get loaded */
+	if (!ast_strlen_zero(category) && catcount == 0) { /* TODO: actually, a config with no categories doesn't even get loaded */
 		astman_append(s, "No categories found");
+	}
 	ast_config_destroy(cfg);
 	astman_append(s, "\r\n");
 
@@ -1183,8 +1257,9 @@
 		astman_append(s, "Category-%06d: %s\r\n", catcount, category);
 		catcount++;
 	}
-	if (catcount == 0) /* TODO: actually, a config with no categories doesn't even get loaded */
+	if (catcount == 0) { /* TODO: actually, a config with no categories doesn't even get loaded */
 		astman_append(s, "Error: no categories found");
+	}
 	ast_config_destroy(cfg);
 	astman_append(s, "\r\n");
 
@@ -1198,8 +1273,9 @@
 static void json_escape(char *out, const char *in)
 {
 	for (; *in; in++) {
-		if (*in == '\\' || *in == '\"')
+		if (*in == '\\' || *in == '\"') {
 			*out++ = '\\';
+		}
 		*out++ = *in;
 	}
 	*out = '\0';
@@ -1246,11 +1322,13 @@
 		}
 		json_escape(buf, category);
 		astman_append(s, "%s\"%s\":[", comma1 ? "," : "", buf);
-		if (!comma1)
+		if (!comma1) {
 			comma1 = 1;
+		}
 		for (v = ast_variable_browse(cfg, category); v; v = v->next) {
-			if (comma2)
+			if (comma2) {
 				astman_append(s, ",");
+			}
 			if (buf_len < 2 * strlen(v->name) + 1) {
 				buf_len *= 2;
 				buf = alloca(buf_len);
@@ -1263,8 +1341,9 @@
 			}
 			json_escape(buf, v->value);
 			astman_append(s, "%s\"", buf);
-			if (!comma2)
+			if (!comma2) {
 				comma2 = 1;
+			}
 		}
 		astman_append(s, "]");
 	}
@@ -1291,8 +1370,9 @@
 
 		snprintf(hdr, sizeof(hdr), "Action-%06d", x);
 		action = astman_get_header(m, hdr);
-		if (ast_strlen_zero(action))
+		if (ast_strlen_zero(action)) {
 			break;
+		}
 		snprintf(hdr, sizeof(hdr), "Cat-%06d", x);
 		cat = astman_get_header(m, hdr);
 		snprintf(hdr, sizeof(hdr), "Var-%06d", x);
@@ -1319,8 +1399,9 @@
 			}
 			if (ast_strlen_zero(match)) {
 				ast_category_append(cfg, category);
-			} else
+			} else {
 				ast_category_insert(cfg, category, match);
+			}
 		} else if (!strcasecmp(action, "renamecat")) {
 			if (ast_strlen_zero(cat) || ast_strlen_zero(value)) {
 				result = UNSPECIFIED_ARGUMENT;
@@ -1388,8 +1469,9 @@
 				result = FAILURE_ALLOCATION;
 				break;
 			}
-			if (object || (match && !strcasecmp(match, "object")))
+			if (object || (match && !strcasecmp(match, "object"))) {
 				v->object = 1;
+			}
 			ast_variable_append(category, v);
 		} else if (!strcasecmp(action, "insert")) {
 			if (ast_strlen_zero(cat) || ast_strlen_zero(var) || ast_strlen_zero(line)) {
@@ -1460,8 +1542,9 @@
 		}
 		astman_send_ack(s, m, NULL);
 		if (!ast_strlen_zero(rld)) {
-			if (ast_true(rld))
+			if (ast_true(rld)) {
 				rld = NULL;
+			}
 			ast_module_reload(rld);
 		}
 	} else {
@@ -1520,8 +1603,9 @@
 	if ((fd = open(filepath->str, O_CREAT | O_EXCL, AST_FILE_MODE)) != -1) {
 		close(fd);
 		astman_send_ack(s, m, "New configuration file created successfully");
-	} else 
+	} else {
 		astman_send_error(s, m, strerror(errno));
+	}
 
 	return 0;
 }
@@ -1543,21 +1627,24 @@
 	const char *id = astman_get_header(m, "ActionID");
 	char idText[256];
 
-	if (!ast_strlen_zero(id))
+	if (!ast_strlen_zero(id)) {
 		snprintf(idText, sizeof(idText), "ActionID: %s\r\n", id);
-	else
+	} else {
 		idText[0] = '\0';
+	}
 
 	if (!ast_strlen_zero(timeouts)) {
 		sscanf(timeouts, "%i", &timeout);
-		if (timeout < -1)
+		if (timeout < -1) {
 			timeout = -1;
+		}
 		/* XXX maybe put an upper bound, or prevent the use of 0 ? */
 	}
 
-	ast_mutex_lock(&s->__lock);
-	if (s->waiting_thread != AST_PTHREADT_NULL)
+	ao2_lock(s);
+	if (s->waiting_thread != AST_PTHREADT_NULL) {
 		pthread_kill(s->waiting_thread, SIGURG);
+	}
 
 	if (s->managerid) { /* AMI-over-HTTP session */
 		/*
@@ -1568,43 +1655,52 @@
 		time_t now = time(NULL);
 		int max = s->sessiontimeout - now - 10;
 
-		if (max < 0)	/* We are already late. Strange but possible. */
+		if (max < 0) {	/* We are already late. Strange but possible. */
 			max = 0;
-		if (timeout < 0 || timeout > max)
+		}
+		if (timeout < 0 || timeout > max) {
 			timeout = max;
-		if (!s->send_events)	/* make sure we record events */
+		}
+		if (!s->send_events) {	/* make sure we record events */
 			s->send_events = -1;
+		}
 	}
-	ast_mutex_unlock(&s->__lock);
+	ao2_unlock(s);
 
 	/* XXX should this go inside the lock ? */
 	s->waiting_thread = pthread_self();	/* let new events wake up this thread */
 	ast_debug(1, "Starting waiting for an event!\n");
 
 	for (x = 0; x < timeout || timeout < 0; x++) {
-		ast_mutex_lock(&s->__lock);
-		if (NEW_EVENT(s))
+		ao2_lock(s);
+		if (NEW_EVENT(s)) {
 			needexit = 1;
+		}
 		/* We can have multiple HTTP session point to the same mansession entry.
 		 * The way we deal with it is not very nice: newcomers kick out the previous
 		 * HTTP session. XXX this needs to be improved.
 		 */
-		if (s->waiting_thread != pthread_self())
+		if (s->waiting_thread != pthread_self()) {
 			needexit = 1;
-		if (s->needdestroy)
+		}
+		if (s->needdestroy) {
 			needexit = 1;
-		ast_mutex_unlock(&s->__lock);
-		if (needexit)
+		}
+		ao2_unlock(s);
+		if (needexit) {
 			break;
+		}
 		if (s->managerid == 0) {	/* AMI session */
-			if (ast_wait_for_input(s->fd, 1000))
+			if (ast_wait_for_input(s->fd, 1000)) {
 				break;
+			}
 		} else {	/* HTTP session */
 			sleep(1);
 		}
 	}
 	ast_debug(1, "Finished waiting for an event!\n");
-	ast_mutex_lock(&s->__lock);
+
+	ao2_lock(s);
 	if (s->waiting_thread == pthread_self()) {
 		struct eventqent *eqe;
 		astman_send_response(s, m, "Success", "Waiting for Event completed.");
@@ -1624,7 +1720,7 @@
 	} else {
 		ast_debug(1, "Abandoning event request!\n");
 	}
-	ast_mutex_unlock(&s->__lock);
+	ao2_unlock(s);
 	return 0;
 }
 
@@ -1641,9 +1737,10 @@
 
 	astman_start_ack(s, m);
 	AST_RWLIST_TRAVERSE(&actions, cur, list) {
-		if (s->writeperm & cur->authority || cur->authority == 0)
+		if (s->writeperm & cur->authority || cur->authority == 0) {
 			astman_append(s, "%s: %s (Priv: %s)\r\n",
 				cur->action, cur->synopsis, authority_to_str(cur->authority, &temp));
+		}
 	}
 	astman_append(s, "\r\n");
 
@@ -1685,14 +1782,22 @@
 
 static int action_login(struct mansession *s, const struct message *m)
 {
+
+	/* still authenticated - don't process again */
+	if (s->authenticated) {
+		astman_send_ack(s, m, "Already authenticated");
+		return 0;
+	}
+
 	if (authenticate(s, m)) {
 		sleep(1);
 		astman_send_error(s, m, "Authentication failed");
 		return -1;
 	}
 	s->authenticated = 1;
-	if (manager_displayconnects(s))
+	if (manager_displayconnects(s)) {
 		ast_verb(2, "%sManager '%s' logged on from %s\n", (s->managerid ? "HTTP " : ""), s->username, ast_inet_ntoa(s->sin.sin_addr));
+	}
 	ast_log(LOG_EVENT, "%sManager '%s' logged on from %s\n", (s->managerid ? "HTTP " : ""), s->username, ast_inet_ntoa(s->sin.sin_addr));
 	astman_send_ack(s, m, "Authentication accepted");
 	return 0;
@@ -1703,12 +1808,13 @@
 	const char *authtype = astman_get_header(m, "AuthType");
 
 	if (!strcasecmp(authtype, "MD5")) {
-		if (ast_strlen_zero(s->challenge))
+		if (ast_strlen_zero(s->challenge)) {
 			snprintf(s->challenge, sizeof(s->challenge), "%ld", ast_random());
-		ast_mutex_lock(&s->__lock);
+		}
+		ao2_lock(s);
 		astman_start_ack(s, m);
 		astman_append(s, "Challenge: %s\r\n\r\n", s->challenge);
-		ast_mutex_unlock(&s->__lock);
+		ao2_unlock(s);
 	} else {
 		astman_send_error(s, m, "Must specify AuthType");
 	}
@@ -1768,8 +1874,9 @@
 
 	pbx_builtin_setvar_helper(c, varname, S_OR(varval, ""));
 
-	if (c)
+	if (c) {
 		ast_channel_unlock(c);
+	}
 
 	astman_send_ack(s, m, "Variable Set");
 
@@ -1811,8 +1918,9 @@
 		pbx_retrieve_variable(c, varname, &varval, workspace, sizeof(workspace), NULL);
 	}
 
-	if (c)
+	if (c) {
 		ast_channel_unlock(c);
+	}
 	astman_start_ack(s, m);
 	astman_append(s, "Variable: %s\r\nValue: %s\r\n\r\n", varname, varval);
 
@@ -1849,14 +1957,15 @@
 	);
 	struct ast_str *str = ast_str_create(1000);
 
-	if (!ast_strlen_zero(id))
+	if (!ast_strlen_zero(id)) {
 		snprintf(idText, sizeof(idText), "ActionID: %s\r\n", id);
-	else
+	} else {
 		idText[0] = '\0';
+	}
 
-	if (all)
+	if (all) {
 		c = ast_channel_walk_locked(NULL);
-	else {
+	} else {
 		c = ast_get_channel_by_name_locked(name);
 		if (!c) {
 			astman_send_error(s, m, "No such channel");
@@ -1891,10 +2000,11 @@
 		}
 
 		channels++;
-		if (c->_bridge)
+		if (c->_bridge) {
 			snprintf(bridge, sizeof(bridge), "BridgedChannel: %s\r\nBridgedUniqueid: %s\r\n", c->_bridge->name, c->_bridge->uniqueid);
-		else
+		} else {
 			bridge[0] = '\0';
+		}
 		if (c->pbx) {
 			if (c->cdr) {
 				elapsed_seconds = now.tv_sec - c->cdr->start.tv_sec;
@@ -1945,8 +2055,9 @@
 			ast_state2str(c->_state), bridge, c->uniqueid, str->str, idText);
 		}
 		ast_channel_unlock(c);
-		if (!all)
+		if (!all) {
 			break;
+		}
 		c = ast_channel_walk_locked(c);
 	}
 	astman_append(s,
@@ -1991,10 +2102,11 @@
 	res = ast_sendtext(c, textmsg);
 	ast_channel_unlock(c);
 	
-	if (res > 0)
+	if (res > 0) {
 		astman_send_ack(s, m, "Success");
-	else
+	} else {
 		astman_send_error(s, m, "Failure");
+	}
 	
 	return res;
 }
@@ -2055,22 +2167,28 @@
 	res = ast_async_goto(chan, context, exten, pi);
 	if (!res) {
 		if (!ast_strlen_zero(name2)) {
-			if (chan2)
+			if (chan2) {
 				res = ast_async_goto(chan2, context, exten, pi);
-			else
+			} else {
 				res = -1;
-			if (!res)
+			}
+			if (!res) {
 				astman_send_ack(s, m, "Dual Redirect successful");
-			else
+			} else {
 				astman_send_error(s, m, "Secondary redirect failed");
-		} else
+			}
+		} else {
 			astman_send_ack(s, m, "Redirect successful");
-	} else
+		}
+	} else {
 		astman_send_error(s, m, "Redirect failed");
-	if (chan)
+	}
+	if (chan) {
 		ast_channel_unlock(chan);
-	if (chan2)
+	}
+	if (chan2) {
 		ast_channel_unlock(chan2);
+	}
 	return 0;
 }
 
@@ -2193,8 +2311,9 @@
 	}
 
 	astman_append(s, "Response: Follows\r\nPrivilege: Command\r\n");
-	if (!ast_strlen_zero(id))
+	if (!ast_strlen_zero(id)) {
 		astman_append(s, "ActionID: %s\r\n", id);
+	}
 	/* FIXME: Wedge a ActionID response in here, waiting for later changes */
 	ast_cli_command(fd, cmd);	/* XXX need to change this to use a FILE * */
 	l = lseek(fd, 0, SEEK_END);	/* how many chars available */
@@ -2216,8 +2335,9 @@
 	close(fd);
 	unlink(template);
 	astman_append(s, "--END COMMAND--\r\n\r\n");
-	if (final_buf)
+	if (final_buf) {
 		ast_free(final_buf);
+	}
 	return 0;
 }
 
@@ -2259,8 +2379,9 @@
 			in->vars, in->account, &chan);
 	}
 
-	if (!chan)
+	if (!chan) {
 		snprintf(requested_channel, AST_CHANNEL_NAME, "%s/%s", in->tech, in->data);	
+	}
 	/* Tell the manager what happened with the channel */
 	manager_event(EVENT_FLAG_CALL, "OriginateResponse",
 		"%s"
@@ -2279,8 +2400,9 @@
 		);
 
 	/* Locked by ast_pbx_outgoing_exten or ast_pbx_outgoing_app */
-	if (chan)
+	if (chan) {
 		ast_channel_unlock(chan);
+	}
 	ast_free(in);
 	return NULL;
 }
@@ -2352,13 +2474,15 @@
 	ast_copy_string(tmp2, callerid, sizeof(tmp2));
 	ast_callerid_parse(tmp2, &n, &l);
 	if (n) {
-		if (ast_strlen_zero(n))
+		if (ast_strlen_zero(n)) {
 			n = NULL;
+		}
 	}
 	if (l) {
 		ast_shrink_phone_number(l);
-		if (ast_strlen_zero(l))
+		if (ast_strlen_zero(l)) {
 			l = NULL;
+		}
 	}
 	if (!ast_strlen_zero(codecs)) {
 		format = 0;
@@ -2375,10 +2499,12 @@
    			ast_copy_string(fast->data, data, sizeof(fast->data));
 			ast_copy_string(fast->app, app, sizeof(fast->app));
 			ast_copy_string(fast->appdata, appdata, sizeof(fast->appdata));
-			if (l)
+			if (l) {
 				ast_copy_string(fast->cid_num, l, sizeof(fast->cid_num));
-			if (n)
+			}
+			if (n) {
 				ast_copy_string(fast->cid_name, n, sizeof(fast->cid_name));
+			}
 			fast->vars = vars;
 			ast_copy_string(fast->context, context, sizeof(fast->context));
 			ast_copy_string(fast->exten, exten, sizeof(fast->exten));
@@ -2411,17 +2537,18 @@
 		}
 		res = ast_pbx_outgoing_app(tech, format, data, to, app, appdata, &reason, 1, l, n, vars, account, NULL);
 	} else {
-		if (exten && context && pi)
+		if (exten && context && pi) {
 			res = ast_pbx_outgoing_exten(tech, format, data, to, context, exten, pi, &reason, 1, l, n, vars, account, NULL);
-		else {
+		} else {
 			astman_send_error(s, m, "Originate with 'Exten' requires 'Context' and 'Priority'");
 			return 0;
 		}
 	}
-	if (!res)
+	if (!res) {
 		astman_send_ack(s, m, "Originate successfully queued");
-	else
+	} else {
 		astman_send_error(s, m, "Originate failed");
+	}
 	return 0;
 }
 
@@ -2509,8 +2636,9 @@
 		astman_send_error(s, m, "Extension not specified");
 		return 0;
 	}
-	if (ast_strlen_zero(context))
+	if (ast_strlen_zero(context)) {
 		context = "default";
+	}
 	status = ast_extension_state(NULL, context, exten);
 	ast_get_hint(hint, sizeof(hint) - 1, NULL, 0, NULL, context, exten);
 	astman_start_ack(s, m);
@@ -2567,7 +2695,7 @@
 {
 	int ret = 0;
 
-	ast_mutex_lock(&s->__lock);
+	ao2_lock(s);
 	if (s->f != NULL) {
 		struct eventqent *eqe;
 
@@ -2582,7 +2710,7 @@
 			s->last_ev = unref_event(s->last_ev);
 		}
 	}
-	ast_mutex_unlock(&s->__lock);
+	ao2_unlock(s);
 	return ret;
 }
 
@@ -2622,10 +2750,11 @@
 	const char *actionid = astman_get_header(m, "ActionID");
 	char idText[150];
 
-	if (!ast_strlen_zero(actionid))
+	if (!ast_strlen_zero(actionid)) {
 		snprintf(idText, sizeof(idText), "ActionID: %s\r\n", actionid);
-	else
+	} else {
 		idText[0] = '\0';
+	}
 
 	astman_append(s, "Response: Success\r\n"
 			"%s"
@@ -2671,10 +2800,11 @@
 	char reloadtime[150];
 	struct ast_tm tm;
 
-	if (!ast_strlen_zero(actionid))
+	if (!ast_strlen_zero(actionid)) {
 		snprintf(idText, sizeof(idText), "ActionID: %s\r\n", actionid);
-	else
+	} else {
 		idText[0] = '\0';
+	}
 
 	ast_localtime(&ast_startuptime, &tm, NULL);
 	ast_strftime(startuptime, sizeof(startuptime), "%H:%M:%S", &tm);
@@ -2707,10 +2837,11 @@
 	const char *module = astman_get_header(m, "Module");
 	int res = ast_module_reload(S_OR(module, NULL));
 
-	if (res == 2)
+	if (res == 2) {
 		astman_send_ack(s, m, "Module Reloaded");
-	else
+	} else {
 		astman_send_error(s, m, s == 0 ? "No such module" : "Module does not support reload");
+	}
 	return 0;
 }
 
@@ -2730,10 +2861,11 @@
 	int numchans = 0;
 	int duration, durh, durm, durs;
 
-	if (!ast_strlen_zero(actionid))
+	if (!ast_strlen_zero(actionid)) {
 		snprintf(actionidtext, sizeof(actionidtext), "ActionID: %s\r\n", actionid);
-	else
+	} else {
 		actionidtext[0] = '\0';
+	}
 
 	astman_send_listack(s, m, "Channels will follow", "start");	
 
@@ -2822,10 +2954,11 @@
 	version = ast_file_version_find(filename);
 #endif
 
-	if (!ast_strlen_zero(id))
+	if (!ast_strlen_zero(id)) {
 		snprintf(idText, sizeof(idText), "ActionID: %s\r\n", id);
-	else
+	} else {
 		idText[0] = '\0';
+	}
 	astman_append(s, "Response: Success\r\n%s", idText);
 #if !defined(LOW_MEMORY)
 	astman_append(s, "Version: %s\r\n\r\n", version ? version : "");
